/**
 * description
 *
 * @author eson
 *2022年7月20日-10:00:05
 */
package com.yuandian.dataflow.statemachine.state;
 

import com.alibaba.nacos.api.cmdb.pojo.Entity;
import com.yuandian.dataflow.statemachine.StateServerFactory;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import lombok.var;
import lombok.extern.slf4j.Slf4j;

/**
 * description
 *
 * @author eson
 *2022年7月20日-10:00:05
 */
@Slf4j
@Getter
@Setter
@ToString
public class StateFactory {

    public static Thread masterExecute = new Thread(new Runnable() {
        @Override
        public void run() { 
            try {
                while(true) {
                    log.debug("master execute {}", StateServerFactory.getServerId());
                    var alivePeers = StateServerFactory.getCluster().getRaftNode().listAlivePeers();
                    log.debug("master execute {}", StateServerFactory.getCluster().getRaftNode().listAlivePeers());
                    if(alivePeers != null) {
                        synchronized(alivePeers) {
                            StateServerFactory.getStateServer().useFsmStateAsync((state)->{
                                alivePeers.forEach((peer)->{
                                    var ws = state.getWorkers().get(peer);
                                    if(ws != null) {
                                        var cap = 10000 - ws.getTaskQueueSize();
                                        if(cap > 0) {
                                            log.debug("{}", cap);
                                           
                                           
                                        }
                                    } 
                                });
                                alivePeers.notify();
                                return null;
                            });
                    }
                  
                }

                    Thread.sleep(2000);
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
           
        }
    });
    
    public static Thread getMasterExecute() {
        return masterExecute;
    }

    public static void Init() {

    } 

 
}
